<script setup lang="ts">
import { ref } from 'vue'

import { useStockDetailStore } from '../../stores/stockDetail'

import type { VForm } from 'vuetify/components'

const stockDetailStore = useStockDetailStore()
const form = ref(true)
const refForm = ref<VForm | null>(null)

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) {
    console.log('erroe validation')
    return
  }
  console.log('edit: ', stockDetailStore.editedStockDetail)
  stockDetailStore.saveStock(stockDetailStore.editedStockDetail)
  stockDetailStore.closeDialog()
}
</script>

<template>
  <v-dialog v-model="stockDetailStore.dialog" persistent width="960">
    <v-card>
      <v-card-title>
        <span class="text-h5">Stock Detail INFO</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form">
          <v-container>
            <v-row>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model.number="stockDetailStore.editedStockDetail.QOH"
                  :readonly="stockDetailStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Quantity"
                >
                </v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model.number="stockDetailStore.editedStockDetail.balance"
                  :readonly="stockDetailStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="balance (Price per unit)"
                >
                </v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model.number="stockDetailStore.editedStockDetail.materialId"
                  :readonly="stockDetailStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Material ID"
                >
                </v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model.number="stockDetailStore.editedStockDetail.StockId"
                  :readonly="stockDetailStore.loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Stock ID"
                >
                </v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="stockDetailStore.closeDialog()">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
